/*******************************************************************************
 * FoxCustomizationNode_Muzzle generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxCustomizationNode_Muzzle extends FoxCustomizationNode_ModProviderBase within FoxArmoryUI
    config(UI);

function Initialize(optional bool bSelectEquipped)
{
    local array<FoxDataProvider_Muzzle> DataProviderList;
    local FoxDataProvider_Muzzle CurrentModProvider;
    local class<FoxWeapon> SelectedWeaponClass;

    bSelectEquipped = true;
    super(FoxCustomizationNode_Base).Initialize(bSelectEquipped);
    SelectedWeaponClass = Outer.GetWeaponClassForType(Outer.SelectedCustomizationType);
    AssociatedUnlockID = SelectedWeaponClass.default.UnlockID;
    // End:0xD5
    if(bSelectEquipped)
    {
        Outer.CustomItemType = 2;
        Outer.ResetSelectedLoadout();
    }
    DataProviderList = Outer.Outer.Outer.UnlockablesDataStore.MuzzleProviderArray;
    // End:0x1AA
    if(Outer.SelectedCustomizationType == 0)
    {
        CurrentModProvider = DataProviderList[Outer.SavedPrimaryWeaponInfo.WeaponMuzzle];
    }
    // End:0x1F1
    else
    {
        CurrentModProvider = DataProviderList[Outer.SavedSecondaryWeaponInfo.WeaponMuzzle];
    }
    SetupProviderCustomScroller(DataProviderList, CurrentModProvider, bSelectEquipped);
    //return;    
}

function ei_changeScrollerIndex(int NewIndex)
{
    local FoxWeaponConfigInfo TempLoadoutInfo;

    // End:0x12A
    if((NewIndex >= 0) && NewIndex < ScrollerEntries.Length)
    {
        // End:0x78
        if(Outer.SelectedCustomizationType == 0)
        {
            TempLoadoutInfo = Outer.CachedPrimaryWeaponInfo;
        }
        // End:0xA0
        else
        {
            TempLoadoutInfo = Outer.CachedSecondaryWeaponInfo;
        }
        TempLoadoutInfo.WeaponMuzzle = byte(SelectedModProviderInfoList[ScrollerEntries[NewIndex].InsertIndex].ModID);
        Outer.UpdateCharacterLoadout(TempLoadoutInfo);
    }
    super(FoxCustomizationNode_Base).ei_changeScrollerIndex(NewIndex);
    //return;    
}

function ei_ScrollerClicked(string SelectedIndex)
{
    local int NextIndex;

    NextIndex = int(SelectedIndex);
    // End:0x12F
    if((NextIndex >= 0) && NextIndex < ScrollerEntries.Length)
    {
        // End:0xEB
        if(Outer.IsReceiverValidForModProvider(SelectedModProviderInfoList[ScrollerEntries[NextIndex].InsertIndex].ModProvider))
        {
            Outer.SelectedScrollerUnlock = ScrollerEntries[NextIndex].UnlockID;
        }
        // End:0x12C
        else
        {
            Outer.ShowEquippingIllegalModPopup();
            Outer.SelectedScrollerUnlock = 0;
            return;
        }
    }
    // End:0x14F
    else
    {
        Outer.SelectedScrollerUnlock = 0;
    }
    super(FoxCustomizationNode_Base).ei_ScrollerClicked(SelectedIndex);
    //return;    
}

function NodeEquipButtonClicked(string SelectedIndex)
{
    local int NextIndex;

    NextIndex = int(SelectedIndex);
    // End:0x1CD
    if((NextIndex >= 0) && NextIndex < ScrollerEntries.Length)
    {
        // End:0x119
        if(Outer.SelectedCustomizationType == 0)
        {
            Outer.CachedPrimaryWeaponInfo.WeaponMuzzle = byte(SelectedModProviderInfoList[ScrollerEntries[NextIndex].InsertIndex].ModID);
            Outer.UpdateCharacterLoadout(Outer.CachedPrimaryWeaponInfo);
        }
        // End:0x1CD
        else
        {
            Outer.CachedSecondaryWeaponInfo.WeaponMuzzle = byte(SelectedModProviderInfoList[ScrollerEntries[NextIndex].InsertIndex].ModID);
            Outer.UpdateCharacterLoadout(Outer.CachedSecondaryWeaponInfo);
        }
    }
    super(FoxCustomizationNode_Base).NodeEquipButtonClicked(SelectedIndex);
    //return;    
}

function SetModIndexToConfig(int ModIndex, out FoxWeaponConfigInfo NewWeaponConfig)
{
    NewWeaponConfig.WeaponMuzzle = byte(ModIndex);
    //return;    
}

function bool IsValidProviderForWeapon(FoxDataProvider_ModBase ModProvider, class<FoxWeapon> SelectedWeaponClass)
{
    // End:0x6E
    if(ModProvider.WhiteRecievers.Length > 0)
    {
        return ModProvider.WhiteRecievers.Find(string(SelectedWeaponClass.Name)) >= 0;
    }
    // End:0xB4
    else
    {
        return class'FoxWeaponMuzzle_Base'.default.WhiteRecievers.Find(string(SelectedWeaponClass.Name)) >= 0;
    }
    //return ReturnValue;    
}
